require "http/server"
require "option_parser"
require "./payload.cr"

VERSION = 0.1
port = 3000

args = []  of String

OptionParser.parse do |parser|
	parser.banner = "usage: webhooksd <scriptfile> [option]"
  parser.on "-v", "--version", "Show version" do
    puts "version #{VERSION}"
    exit
  end

  parser.on "-h", "--help", "Show help" do
    puts parser
    exit
  end

	parser.on "-p PORT", "--port=PORT", "Port to listen for connections. Default: 3000" do |p|
		port = p.to_i
	end

	parser.invalid_option do |flag|
		STDERR.puts "ERROR: #{flag} is not a valid option."
		STDERR.puts parser
		exit 1
	end

	parser.unknown_args do |x|
		args = x

		if args.size < 1
			puts parser
			exit 1
		end
	end
end

scriptfile = args[0]

if File.exists?(scriptfile) == false
	STDERR.puts "ERROR: #{scriptfile} don't exists."
	exit 2
end

server = HTTP::Server.new do |context|
	if context.request.method != "POST" || context.request.path != "/"
		context.response.status = HTTP::Status::NOT_FOUND
	else
		payload = Payload.new(context.request)

  	context.response.content_type = "text/plain"
		if Process.run command: "sh", args: [scriptfile], shell: true,
				error: STDERR, output: STDOUT, chdir: Process::INITIAL_PWD
			context.response.print "SUCCESS"
		else
			context.response.print "FAILURE"
		end
	end
end

address = server.bind_tcp port
server.listen
